"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs-extra"));
const xml2js = __importStar(require("xml2js"));
const format = require("xml-formatter");
const nonArayProperties = [
    "custom",
    "description",
    "fullName",
    "userLicense",
    "$"
];
const PROFILE_NAMESPACE = "http://soap.sforce.com/2006/04/metadata";
class ProfileWriter {
    writeProfile(profileObj, filePath) {
        //Delete eampty arrays
        for (let key in profileObj) {
            if (Array.isArray(profileObj[key])) {
                //All top element must be arays exept non arrayProperties
                if (!nonArayProperties.includes(key) && profileObj[key].length === 0) {
                    delete profileObj[key];
                }
            }
        }
        let builder = new xml2js.Builder({
            rootName: "Profile",
            xmldec: { version: "1.0", encoding: "UTF-8" }
        });
        profileObj["$"] = {
            xmlns: PROFILE_NAMESPACE
        };
        let xml = builder.buildObject(profileObj);
        let formattedXml = format(xml, {
            indentation: "    ",
            filter: node => node.type !== "Comment",
            collapseContent: true,
            lineSeparator: "\n"
        });
        //console.log(formattedXml);
        fs.writeFileSync(filePath, formattedXml);
    }
    toXml(profileObj) {
        //Delete eampty arrays
        for (let key in profileObj) {
            if (Array.isArray(profileObj[key])) {
                //All top element must be arays exept non arrayProperties
                if (!nonArayProperties.includes(key) && profileObj[key].length === 0) {
                    delete profileObj[key];
                }
            }
        }
        let builder = new xml2js.Builder({
            rootName: "Profile",
            xmldec: { version: "1.0", encoding: "UTF-8" }
        });
        profileObj["$"] = {
            xmlns: PROFILE_NAMESPACE
        };
        let xml = builder.buildObject(profileObj);
        let formattedXml = format(xml, {
            indentation: "    ",
            filter: node => node.type !== "Comment",
            collapseContent: true,
            lineSeparator: "\n"
        });
        return formattedXml;
    }
    toProfile(profileObj) {
        var convertedObject = {};
        for (var key in profileObj) {
            if (Array.isArray(profileObj[key])) {
                //All top element must be arays exept non arrayProperties
                if (nonArayProperties.includes(key)) {
                    convertedObject[key] =
                        profileObj[key][0] === "true"
                            ? true
                            : profileObj[key][0] === "false"
                                ? false
                                : profileObj[key][0];
                }
                else {
                    var data = [];
                    for (var i = 0; i < profileObj[key].length; i++) {
                        var element = this.removeArrayNatureOnValue(profileObj[key][i]);
                        if (element !== "") {
                            data.push(element);
                        }
                    }
                    convertedObject[key] = data;
                }
            }
            else if (nonArayProperties.includes(key)) {
                convertedObject[key] = profileObj[key];
            }
        }
        return convertedObject;
    }
    removeArrayNatureOnValue(obj) {
        var toReturn = {};
        for (var key in obj) {
            if (Array.isArray(obj[key]) && obj[key].length > 0) {
                //All top element must be arays exept non arrayProperties
                toReturn[key] =
                    obj[key][0] === "true"
                        ? true
                        : obj[key][0] === "false"
                            ? false
                            : obj[key][0];
            }
            else {
                toReturn[key] = obj[key];
            }
        }
        return toReturn;
    }
}
exports.default = ProfileWriter;
//# sourceMappingURL=profileWriter.js.map