"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ApexTypeListener {
    constructor() {
        this.apexType = {
            class: false,
            testClass: false,
            interface: false,
        };
    }
    enterAnnotation(ctx) {
        if (ctx._stop.text.toUpperCase() === "ISTEST") {
            this.apexType["testClass"] = true;
        }
    }
    enterInterfaceDeclaration(ctx) {
        this.apexType["interface"] = true;
    }
    enterClassDeclaration(ctx) {
        this.apexType["class"] = true;
    }
    getApexType() {
        return this.apexType;
    }
}
exports.default = ApexTypeListener;
//# sourceMappingURL=ApexTypeListener.js.map