"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const process_errors_1 = require("./process-errors");
const run_1 = require("./run");
const sendResolved = value => {
    process.send({
        type: "resolved",
        value
    });
};
const sendRejected = value => {
    process.send({
        type: "rejected",
        value: process_errors_1.parseErrors(value)
    });
};
function onMessage(message) {
    process.removeListener("message", onMessage);
    if (message &&
        message.commandId &&
        message.commandName &&
        message.commandFile) {
        const { commandId, commandName, commandFile, flags, opts } = message;
        try {
            const command = run_1.createCommand(commandId, commandName, commandFile);
            const value = command(flags, opts);
            if (value && typeof value.then === "function") {
                value.then(sendResolved).catch(sendRejected);
            }
            else {
                sendResolved(value);
            }
        }
        catch (err) {
            sendRejected(err);
        }
    }
}
process.on("message", onMessage);
//# sourceMappingURL=child.js.map