"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerNamespace = exports.sfdx = void 0;
const child_process_1 = require("child_process");
const path = __importStar(require("path"));
const builder_1 = require("./builder");
const types_1 = require("./types");
const createParallelCommand = (commandId, commandName, commandFile) => (flags, opts) => new Promise((resolve, reject) => {
    let child_path = __dirname.toString();
    if (path.basename(path.dirname(child_path)) == "src") {
        //Run in linking, ts is ran using ts-node, so use the compiled child.js
        //Linked
        child_path = path.join(path.dirname(path.dirname(child_path)), "lib", "sfdxnode");
    }
    const child = child_process_1.fork(path.join(child_path, "./child.js"), ["--colors"], {
        cwd: flags.cwd ? flags.cwd.toString() : null,
    });
    child.on("message", (message) => {
        if (message.type === "resolved") {
            resolve(message.value);
        }
        else if (message.type === "rejected") {
            reject(message.value);
        }
    });
    const childMsg = {
        commandFile,
        commandId,
        commandName,
        flags,
        opts,
    };
    child.send(childMsg);
});
exports.sfdx = new types_1.SfdxApi();
function registerNamespace(sfdxNamespace) {
    const { commandsDir, namespace } = sfdxNamespace;
    exports.sfdx[namespace] = builder_1.buildCommands(createParallelCommand, commandsDir, namespace);
}
exports.registerNamespace = registerNamespace;
//# sourceMappingURL=parallel.js.map