"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseErrors = void 0;
exports.parseErrors = (sfdxErrors) => Array.isArray(sfdxErrors)
    ? sfdxErrors.map(parseError)
    : [parseError(sfdxErrors)];
function parseError(error) {
    function hasOwnProperty(value) {
        return (error || {}).hasOwnProperty && (error || {}).hasOwnProperty(value);
    }
    if (hasOwnProperty("error")) {
        return parseError(error.error);
    }
    else if (error instanceof Error) {
        return parseNativeError(error);
    }
    else if (hasOwnProperty("message")) {
        return error;
    }
    else if (typeof error === "string") {
        return { message: error };
    }
    const str = String(error);
    return {
        message: str !== "[object Object]" ? str : JSON.stringify(error)
    };
}
const parseNativeError = (error) => {
    return Object.getOwnPropertyNames(error).reduce((result, key) => {
        if (key !== "__proto__" && typeof error[key] !== "function") {
            result[key] = error[key];
        }
        return result;
    }, {
        message: ""
    });
};
//# sourceMappingURL=process-errors.js.map