"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserEmail = void 0;
const util_1 = require("util");
const sfpowerkit_1 = require("../sfpowerkit");
let retry = require("async-retry");
async function getUserEmail(username, hubOrg) {
    let hubConn = hubOrg.getConnection();
    return await retry(async (bail) => {
        if (util_1.isNullOrUndefined(username)) {
            bail(new Error("username cannot be null. provide a valid username"));
            return;
        }
        let query = `SELECT email FROM user WHERE username='${username}'`;
        sfpowerkit_1.SFPowerkit.log("QUERY:" + query, sfpowerkit_1.LoggerLevel.TRACE);
        const results = (await hubConn.query(query));
        if (results.records.size < 1) {
            bail(new Error(`No user found with username ${username} in devhub.`));
            return;
        }
        return results.records[0].Email;
    }, { retries: 3, minTimeout: 3000 });
}
exports.getUserEmail = getUserEmail;
//# sourceMappingURL=getUserDetails.js.map